<?php

/* ----------------------------------------------------------------------------------
 *
 * Xaseco2 plugin paying planets to a random player.
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			ML aka RookieNouse aka nouseforname @ http://www.tm-forum.com
 * Home: 			http://nouseforname.de
 * Date: 			16.05.2012
 * Version:			1.0.3
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */
  
Aseco::registerEvent('onEndMap', 'NouseRandomPay');
Aseco::registerEvent('onSync', 'NouseRandomPayUpToDate');
//Aseco::registerEvent('onEverySecond', 'NouseRandomPay');

function NouseRandomPayUpToDate($aseco) {
    $aseco->plugin_versions[] = array(
        'plugin'	=> 'plugin.nouse.randompay.php',
        'author'	=> 'Nouseforname',
        'version'	=> '1.0.3'
    );
}

function NouseRandomPay ($aseco) {

    $limit 				= 2; 		// player limit to enable random payment
    $minserverplanets 	= 1000; 	// minimum amount of server planets
    $minpay 			= 20; 		// minimum amount to pay
    $maxpay				= 150; 		// maximum amount to pay

    $rocOnly 			= false; 	// set this to true if you want it only during 100k ladder state

/* ================================================================================= */
	
	
	
    $active = false;
    $aseco->client->query('GetServerPlanets');
    $planets = $aseco->client->getResponse();            
    $aseco->client->query('GetLadderServerLimits');
    $ladderlimits = $aseco->client->getResponse();
    $ladder = $ladderlimits['LadderServerLimitMax'];
    if ($rocOnly == true && $ladder == 100000) {
        $active = true;
    } elseif ($rocOnly == false) {
        $active = true;
    }

	if ($active) {
		if ($planets >= $minserverplanets) {
			$ranking = array();
			$aseco->client->query('GetCurrentRanking', 200, 0);
			$ranking = $aseco->client->getResponse();
			$ranks = array();
			foreach ($ranking as $key => $var) {
				if ($var['BestTime'] > 0 || $var['Score'] > 0) {
					$ranks[] = array($var['Login'], $var['NickName']);
				}
			}
			
			// check if enough players finished track
			if (count($ranks) >= $limit) {
				$x = mt_rand(0, (count($ranks)-1));
				$planets = mt_rand($minpay, $maxpay);		
				if ($ranks[$x][0]) {
					$message = '$ff0> Lottery: '.$ranks[$x][1].' $g$z$6c0$s$iwon '.$planets.' planets!!!';
					$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
					$message = 'You won '.$planets.' planets in lottery!'; 
					$aseco->client->addCall('Pay', array($ranks[$x][0], (int)$planets, $aseco->formatColors($message)));	
				} 			
			}  
		} else {
			$message = '$ff0> $g$z$6c0$s$iServer planets to low, random payment disabled. Please donate some.';
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	}
}
?>